/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.tobee.opencv.detector;

import com.tobee.opencv.detector.tests.input.DNNOption;
import javax.swing.JOptionPane;


/**
 *
 * @author User
 */
public class ObjectDetectorMain {
    
   public static void main(String[] args)
   {
       DNNOption dnnOption = new DNNOption();
       IObjectDetector detector = null;
       
       if(dnnOption.setUpOptions() != null && dnnOption.isValid())
       {
           if(dnnOption.modelName.equals(ObjectDetector.MODEL_MASK_RCNN))
           {
               detector = new MaskRCNNDetector(dnnOption);
           }
           else if(dnnOption.modelName.equals(ObjectDetector.MODEL_YOLO))
           {
               detector = new YoloDetector(dnnOption);
           }
           
           if(detector != null)
           {
               detector.detectObject();
           }
       }
       else
       {
           JOptionPane.showMessageDialog(null, "Please retry after checking your options.", "Insufficient option", JOptionPane.WARNING_MESSAGE);
       }
   }
}
