/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JFrame.java to edit this template
 */
package com.tobee.opencv.detector.swing;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.filechooser.FileNameExtensionFilter;
import org.opencv.core.Core;
import org.opencv.core.Mat;
import org.opencv.core.MatOfByte;
import org.opencv.imgcodecs.Imgcodecs;
import org.opencv.videoio.VideoCapture;

/**
 *
 * @author AA160
 */
public class ObjectDetectorFrame extends JFrame {

    /**
     * Creates new form JFrameOpenCV
     */
    public ObjectDetectorFrame() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btnStopCVFrame = new javax.swing.JButton();
        ComboCVFileType = new javax.swing.JComboBox<>();
        openCVScrollPane = new javax.swing.JScrollPane();
        openCVRenderPane = new OpenCVRenderPane();
        filePathTextField = new javax.swing.JTextField();
        btnStart = new javax.swing.JButton();
        comboModel = new javax.swing.JComboBox<>();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        btnStopCVFrame.setText("Stop");
        btnStopCVFrame.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnStopCVFrameActionPerformed(evt);
            }
        });

        ComboCVFileType.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "None", "Image", "Mov", "Cam" }));
        ComboCVFileType.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ComboCVFileTypeActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout openCVRenderPaneLayout = new javax.swing.GroupLayout(openCVRenderPane);
        openCVRenderPane.setLayout(openCVRenderPaneLayout);
        openCVRenderPaneLayout.setHorizontalGroup(
            openCVRenderPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 607, Short.MAX_VALUE)
        );
        openCVRenderPaneLayout.setVerticalGroup(
            openCVRenderPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 446, Short.MAX_VALUE)
        );

        openCVScrollPane.setViewportView(openCVRenderPane);

        openCVScrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        openCVScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);

        filePathTextField.setText("print file path you selected...");

        btnStart.setText("Start");

        comboModel.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "None", "MaskRCNN", "YOLO" }));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(filePathTextField)
                    .addComponent(openCVScrollPane))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(comboModel, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(ComboCVFileType, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(btnStopCVFrame, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(btnStart, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(ComboCVFileType, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(comboModel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(104, 104, 104)
                        .addComponent(btnStart)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnStopCVFrame))
                    .addComponent(openCVScrollPane, javax.swing.GroupLayout.PREFERRED_SIZE, 448, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(filePathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    
    private void btnStopCVFrameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnStopCVFrameActionPerformed
       String cmd = evt.getActionCommand();
       
       switch(cmd)
        {
           case "IMG_STOP":
            break;
            case "MOV_STOP":
                ((OpenCVRenderPane)openCVRenderPane).onCVBufferStop();
            case "CAM_STOP":
                ((OpenCVRenderPane)openCVRenderPane).onCVBufferStop();
            break;
        }
    }//GEN-LAST:event_btnStopCVFrameActionPerformed

    private void ComboCVFileTypeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ComboCVFileTypeActionPerformed
       JComboBox comboBox = null;
       
       if( evt.getSource() instanceof JComboBox)
       {
           comboBox = (JComboBox)evt.getSource();
       }
       
       if(comboBox == null) return;
       
       String itemName = (String)comboBox.getSelectedItem();
       
       String initDir = System.getProperty("opencv.mov.dir");
       
       File chooseFile = null;
       int returnType;
       JFileChooser jFileChooser = null;
       FileNameExtensionFilter extFilter;
       String title = "choose ";
       
       ((OpenCVRenderPane)openCVRenderPane).onCVBufferStop();
       
       switch(itemName)
       {
           case "Image" -> {
               jFileChooser = new JFileChooser(initDir);
               extFilter = new FileNameExtensionFilter("images", "jpg", "jpeg", "png");
               jFileChooser.setFileFilter(extFilter);
               // jFileChooser.addChoosableFileFilter(extFilter);
               title += itemName;
            }
           case "Mov" -> {
               jFileChooser = new JFileChooser(initDir);
               extFilter = new FileNameExtensionFilter("movies", "mp4", "avi");
               jFileChooser.setFileFilter(extFilter);
               //jFileChooser.addChoosableFileFilter(extFilter);
               title += itemName;
            }
            case "Cam" -> {
                ((OpenCVRenderPane)openCVRenderPane).onCVBufferReady(chooseFile, OpenCVRenderPane.CV_CAM_BUFFER);
                btnStopCVFrame.setActionCommand("CAM_STOP");
            }
             case "None" -> {
                 return;
            }
           default -> {
            }
       }
        //do nothing

       if(jFileChooser == null) return;
       
        returnType = jFileChooser.showDialog(this, title);
        
        //System.out.println(itemName);
        
        switch(itemName)
        {
           case "Image" -> {
               switch(returnType)
               {
                   case JFileChooser.APPROVE_OPTION:
                       chooseFile = jFileChooser.getSelectedFile();
                       filePathTextField.setText(chooseFile.getAbsolutePath());
                       ((OpenCVRenderPane)openCVRenderPane).onCVBufferReady(chooseFile, OpenCVRenderPane.CV_IMG_BUFFER);
                       
                       btnStopCVFrame.setActionCommand("IMG_STOP");
                       
                       break;
                   case JFileChooser.CANCEL_OPTION:
                       JOptionPane.showConfirmDialog(null,
                               "Canceled file selection by user",
                               title,
                               JOptionPane.INFORMATION_MESSAGE);
                       
                       break;
                   default:
                       //do nothing
               }
            }
           case "Mov" -> {
               switch(returnType)
               {
                   case JFileChooser.APPROVE_OPTION -> {
                       chooseFile = jFileChooser.getSelectedFile();
                       filePathTextField.setText(chooseFile.getAbsolutePath());
                       ((OpenCVRenderPane)openCVRenderPane).onCVBufferReady(chooseFile, OpenCVRenderPane.CV_MOV_BUFFER);
                       btnStopCVFrame.setActionCommand("MOV_STOP");
               }
                   case JFileChooser.CANCEL_OPTION -> JOptionPane.showConfirmDialog(null,
                               "Canceled file selection by user",
                               title,
                               JOptionPane.INFORMATION_MESSAGE);
                   default -> {
               }
               }
           //do nothing
                       }
           default -> {
            }
       }
        //do nothing
    }//GEN-LAST:event_ComboCVFileTypeActionPerformed
    
    static final class OpenCVRenderPane extends JPanel {
	private static final long serialVersionUID = 1L;
        
        static{
            System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
        }
                
        static final int CV_NON_BUFFER = 0;
        static final int CV_IMG_BUFFER = 1;
        static final int CV_MOV_BUFFER = 2;
        static final int CV_CAM_BUFFER = 3;
        
        private static int mCVTypeNow = CV_NON_BUFFER;
	private BufferedImage cvBuffer;
        private Mat cvFrame;// = new Mat();
        private Thread freamThread;
        private boolean isClose = false;
        
        private static VideoCapture capture;
        
        public OpenCVRenderPane() {
            if(capture == null)
                capture = new VideoCapture();
        }
        
        private void close() {
            isClose = true;
        }
        
//	@Override
//	public Dimension getPreferredSize() {
//            return new Dimension(240, 220);
//	}
        
        private void onCVBufferStop() {
            if(capture != null && capture.isOpened())
                capture.release();           
        }
        
        @Override
        public Dimension getPreferredSize() {
            if (cvBuffer == null) {
                return super.getPreferredSize();
            } else {
                int w = cvBuffer.getWidth();
                int h = cvBuffer.getHeight();
                return new Dimension(w, h);
            }
        }
        
        private final Runnable movRunner = new Runnable()
        {
            @Override
            public void run() {
                //throw new UnsupportedOperationException("Not supported yet."); 
                System.out.println("opened...." + isClose);
                
                while(!isClose)
                { 
                    if(!capture.isOpened()) return;
                    
                    //System.out.println("opened....1");
                    //Mat cvFrame = new Mat();
                    capture.read(cvFrame);
                    if (!cvFrame.empty()){

                        try {
                            cvBuffer = toBufferedImage(cvFrame);
                        } catch (IOException ex) {
                            Logger.getLogger(ObjectDetectorFrame.class.getName()).log(Level.SEVERE, null, ex);
                        }
                        cvFrame.release();
                    }
                    else
                    {
                        System.out.println("Cam fream is empty..");
                    }
                    
                    try {
                        Thread.sleep(150);
                    } catch (InterruptedException ex) {
                        Logger.getLogger(ObjectDetectorFrame.class.getName()).log(Level.SEVERE, null, ex);
                        capture.release();
                    }
                    repaint();
                }
                
            }
            
        };
     
        public void onCVBufferReady(File cvFile, int renderType)
	{
            mCVTypeNow = renderType;
            
            switch(mCVTypeNow)
            {
                case CV_IMG_BUFFER -> {
                    try {
                        cvBuffer = ImageIO.read(cvFile);
                    } catch (IOException ex) {
                        Logger.getLogger(ObjectDetectorFrame.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }

                case CV_MOV_BUFFER -> {
                    if(capture.isOpened())
                    {
                       capture.release();
                    }
                    
                    capture.open(cvFile.getAbsolutePath());
                    cvFrame = new Mat();
                    
                    isClose = false;
                    
                    freamThread = new Thread(movRunner);
                    //freamThread = new Thread(movRunner2);
                    freamThread.setDaemon(true);
                    freamThread.start();
                 }
                case CV_CAM_BUFFER -> {
                    System.out.println(CV_CAM_BUFFER);
                    if(capture.isOpened())
                    {
                       capture.release();
                    }
       
                    capture.open(0);
                    cvFrame = new Mat();
                    
                    isClose = false;
                    
                    freamThread = new Thread(movRunner);
                    //freamThread = new Thread(movRunner2);
                    freamThread.setDaemon(true);
                    freamThread.start();
                 }
            }
            repaint();
            
	}
        
	@Override
	protected void paintComponent(Graphics g) {
            super.paintComponent(g);
            
            if (cvBuffer != null) {
                Graphics2D g2d = (Graphics2D) g.create();
                int x = (getWidth() - cvBuffer.getWidth()) / 2;
                int y = (getHeight() - cvBuffer.getHeight()) / 2;
                g2d.drawImage(cvBuffer, x, y, this);
                g2d.dispose();
                cvBuffer.flush();
                //System.out.println("opened....11");
            }
            
	}
        
        public static BufferedImage toBufferedImage(Mat matrix)throws IOException {
            MatOfByte mob=new MatOfByte();
            Imgcodecs.imencode(".jpg", matrix, mob);
            return ImageIO.read(new ByteArrayInputStream(mob.toArray()));
        }

        public static Mat toMat(BufferedImage image) throws IOException {
            ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
            ImageIO.write(image, "jpg", byteArrayOutputStream);
            byteArrayOutputStream.flush();
            return Imgcodecs.imdecode(new MatOfByte(byteArrayOutputStream.toByteArray()), Imgcodecs.IMREAD_UNCHANGED);
        }

        

        
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ObjectDetectorFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(() -> {
            new ObjectDetectorFrame().setVisible(true);
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox<String> ComboCVFileType;
    private javax.swing.JButton btnStart;
    private javax.swing.JButton btnStopCVFrame;
    private javax.swing.JComboBox<String> comboModel;
    private javax.swing.JTextField filePathTextField;
    private javax.swing.JPanel openCVRenderPane;
    private javax.swing.JScrollPane openCVScrollPane;
    // End of variables declaration//GEN-END:variables
}
