package com.tobee.opencv.detector.tests;

public class TestUtils {
	public static final String CLASSES_FILE = "models/mscoco_labels.names";
	public static final String COLOR_FILE = "models/colors.txt";
	public static final String IMAGE_SRC_FILE = "images/cars.jpg";
	public static final String VIDEO_SRC_FILE = "images/cars.mp4";

//	String keys = new StringBuilder().append(
//	"{help h usage ? | | Usage examples: \n\t\t./mask-rcnn.out --image=traffic.jpg \n\t\t./mask-rcnn.out --video=sample.mp4}")
//	.append("\r\n").append("{image i        |<none>| input image   }").append("\r\n")
//	.append("{video v       |<none>| input video   }").append("\r\n")
//	.append("{device d       |<none>| device }").toString();
	
	public static final String TEXT_GRAPH = "models/mask_rcnn_inception_v2_coco_2018_01_28.pbtxt";
	public static final String MODEL_WEIGHTS_MASK_RCNN = "models/mask_rcnn_inception_v2_coco_2018_01_28/frozen_inference_graph.pb";
	
	public static org.apache.commons.cli.Options setupOptions4MskRCNN() {
		org.apache.commons.cli.Options options = new org.apache.commons.cli.Options();

		org.apache.commons.cli.Option imageOpt 
		= new org.apache.commons.cli.Option("i", "image", true, "input image");
		// imageOpt.setRequired(true);
		org.apache.commons.cli.Option videoOpt 
		= new org.apache.commons.cli.Option("v", "video", true, "input video");
		// videoOpt.setRequired(true);
		org.apache.commons.cli.Option colorOpt 
		= new org.apache.commons.cli.Option("c", "color", true, "color file");
		// videoOpt.setRequired(true);
		org.apache.commons.cli.Option deviceOpt 
		= new org.apache.commons.cli.Option("d", "device", true, "device type");
		// deviceOpt.setRequired(true);
		org.apache.commons.cli.Option labelOpt 
		= new org.apache.commons.cli.Option("l", "label", true, "label file");
		// deviceOpt.setRequired(true);
		
		org.apache.commons.cli.Option rcnnModelOpt 
		= new org.apache.commons.cli.Option("m", "model", true, "RCNN model");
		// yoloModelOpt.setRequired(true);
		
		org.apache.commons.cli.Option grphOpt 
		= new org.apache.commons.cli.Option("g", "graph", true, "RCNN graph");
		// yoloModelOpt.setRequired(true);
		
		options.addOption(imageOpt);
		options.addOption(videoOpt);
		options.addOption(deviceOpt);
		options.addOption(colorOpt);
		options.addOption(labelOpt);
		options.addOption(rcnnModelOpt);
		options.addOption(grphOpt);
		
		return options;
	}
	
	public static final String MODEL_WEIGHTS_YOLO_V3 = "models/yolo/yolov3.weights";
	public static final String CONFIG_YOLO_V3 = "models/yolo/yolov3.cfg";
	
	public static org.apache.commons.cli.Options setupOptions4YoloV3() {
		org.apache.commons.cli.Options options = new org.apache.commons.cli.Options();

		org.apache.commons.cli.Option imageOpt 
		= new org.apache.commons.cli.Option("i", "image", true, "input image");
		// imageOpt.setRequired(true);
		org.apache.commons.cli.Option videoOpt 
		= new org.apache.commons.cli.Option("v", "video", true, "input video");
		// videoOpt.setRequired(true);
		org.apache.commons.cli.Option yoloModelOpt 
		= new org.apache.commons.cli.Option("m", "model", true, "yolo model");
		// yoloModelOpt.setRequired(true);
		
		org.apache.commons.cli.Option yoloConfOpt 
		= new org.apache.commons.cli.Option("c", "config", true, "yolo config");
		// yoloModelOpt.yoloConfOpt(true);
		
		org.apache.commons.cli.Option deviceOpt 
		= new org.apache.commons.cli.Option("d", "device", true, "device type");
		// deviceOpt.setRequired(true);
		
		org.apache.commons.cli.Option labelOpt 
		= new org.apache.commons.cli.Option("l", "label", true, "label file");
		// deviceOpt.setRequired(true);
		
		options.addOption(imageOpt);
		options.addOption(videoOpt);
		options.addOption(yoloModelOpt);
		options.addOption(yoloConfOpt);
		options.addOption(deviceOpt);
		options.addOption(labelOpt);

		return options;
	}

}
