/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.tobee.opencv.detector.tests.input;

import com.tobee.opencv.detector.ObjectDetector;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.io.File;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 *
 * @author User
 */
public class DNNOption {
    public String modelName;
    public String mediaType;
    public String deviceType;

    public String mediaFile;
    public String modelPath;
    public String modelConfiguration;
    public String WinName = "Object detection in OpenCV";
    public boolean isSaveOutput;
    public boolean isMaskShading;
    public double threshold; // Confidence threshold
    
    public boolean isValid()
    {
        boolean isValid;

        isValid = (mediaFile == null ? false : (mediaFile.isBlank() ? false : (!mediaFile.isEmpty())));
        System.out.println(isValid);
        //System.out.println(mediaFile != null && !mediaFile.isBlank() && mediaFile.isEmpty());
        if(!isValid) return false;
        isValid = mediaFile == null ? false : (mediaFile.isBlank() ? false : (!mediaFile.isEmpty()));
        System.out.println(isValid);
        if(!isValid) return false;
        isValid = modelPath == null ? false : (modelPath.isBlank() ? false : (!modelPath.isEmpty()));
        System.out.println(isValid);
        if(!isValid) return false;
        isValid = modelConfiguration == null ? false : (modelConfiguration.isBlank() ? false : (!modelConfiguration.isEmpty()));
        System.out.println(isValid);
        if(!isValid) return false;

        return isValid;
    }

    public DNNOption setUpOptions() {
        // Create main panel
        JPanel panel = new JPanel();
        panel.setPreferredSize(new Dimension(400,350));
        panel.setLayout(new GridBagLayout());
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.insets = new Insets(5, 5, 5, 5);
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.gridx = 0;
        gbc.gridy = 0;

        // Create a JComboBox group
        JPanel comboBoxGroup = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 0));
        JComboBox<String> comboModelName = new JComboBox<>(new String[]{ObjectDetector.TYPE_NONE, ObjectDetector.MODEL_YOLO, ObjectDetector.MODEL_MASK_RCNN});
        JComboBox<String> comboMediaType = new JComboBox<>(new String[]{ObjectDetector.TYPE_NONE, ObjectDetector.TYPE_IMAGE, ObjectDetector.TYPE_VIDEO});
        JComboBox<String> comboDeviceType = new JComboBox<>(new String[]{ObjectDetector.TYPE_CPU, ObjectDetector.TYPE_GPU});
        comboBoxGroup.add(comboModelName);
        comboBoxGroup.add(comboMediaType);
        comboBoxGroup.add(comboDeviceType);
        comboModelName.setPreferredSize(new Dimension(100,30));
        comboMediaType.setPreferredSize(new Dimension(100,30));
        comboDeviceType.setPreferredSize(new Dimension(100, 30));
        panel.add(comboBoxGroup, gbc);
        comboBoxGroup.setPreferredSize(new Dimension(320,40));

        // Create  JTextField + JButton Group
        gbc.gridy++;
        JPanel group1 = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 0));
        JPanel ingroup1 = new JPanel(new BorderLayout());
        JLabel lblModel = new JLabel("Model: ");
        JTextField txtModel = new JTextField(10);
        JButton btnFind1 = new JButton("Find");

        txtModel.setPreferredSize(new Dimension(200,30));
        btnFind1.setPreferredSize(new Dimension(60,30));

        ingroup1.add(lblModel,BorderLayout.WEST);
        ingroup1.add(txtModel,BorderLayout.CENTER);
        ingroup1.add(btnFind1,BorderLayout.EAST);
        ingroup1.setPreferredSize(new Dimension(310,30));

        group1.setPreferredSize(new Dimension(350,40));
        group1.add(ingroup1);

        panel.add(group1, gbc);

        // Create  JTextField + JButton Group
        gbc.gridy++;
        JPanel group2 = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 0));
        JPanel ingroup2 = new JPanel(new BorderLayout());
        group2.setPreferredSize(new Dimension(100,100));
        JLabel lblConfig = new JLabel("Config: ");
        JTextField txtConfig = new JTextField(10);
        JButton btnFind2 = new JButton("Find");

        txtConfig.setPreferredSize(new Dimension(200,30));
        btnFind2.setPreferredSize(new Dimension(60,30));

        ingroup2.add(lblConfig,BorderLayout.WEST);
        ingroup2.add(txtConfig,BorderLayout.CENTER);
        ingroup2.add(btnFind2,BorderLayout.EAST);
        ingroup2.setPreferredSize(new Dimension(310,30));

        group2.setPreferredSize(new Dimension(350,40));
        group2.add(ingroup2);

        panel.add(group2, gbc);

        // Create  JTextField + JButton Group 
        gbc.gridy++;
        JPanel group3 = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 0));
        JPanel ingroup3 = new JPanel(new BorderLayout());
        group3.setPreferredSize(new Dimension(100,100));
        JLabel lblFileIn = new JLabel("InFile: ");
        JTextField txtFileIn = new JTextField(10);
        JButton btnFind3 = new JButton("Find");

        txtFileIn.setPreferredSize(new Dimension(200,30));
        btnFind3.setPreferredSize(new Dimension(60,30));

        ingroup3.add(lblFileIn,BorderLayout.WEST);
        ingroup3.add(txtFileIn,BorderLayout.CENTER);
        ingroup3.add(btnFind3,BorderLayout.EAST);
        ingroup3.setPreferredSize(new Dimension(310,30));

        group3.setPreferredSize(new Dimension(350,40));
        group3.add(ingroup3);

        panel.add(group3, gbc);
        
        // Create  JLabel + JCheckBox Group 
        gbc.gridy++;
        JPanel group4 = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 0));
        JPanel ingroup4 = new JPanel(new BorderLayout());
        group4.setPreferredSize(new Dimension(100,100));
        JLabel lblThreshold = new JLabel("Threshold: ");
        JTextField txtThreshold = new JTextField();
        txtThreshold.setHorizontalAlignment(JTextField.RIGHT);
        txtThreshold.setText("0.5");
        
        ingroup4.add(lblThreshold,BorderLayout.WEST);
        ingroup4.add(txtThreshold,BorderLayout.CENTER);
        //ingroup4.add(btnFind3,BorderLayout.EAST);
        ingroup4.setPreferredSize(new Dimension(310,30));
        
        group4.setPreferredSize(new Dimension(350,40));
        group4.add(ingroup4);

        panel.add(group4, gbc);
        
        // Create  JLabel + JCheckBox Group 
        gbc.gridy++;
        JPanel group5 = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 0));
        JPanel ingroup5 = new JPanel(new BorderLayout());
        //ingroup5.setPreferredSize(new Dimension(100,100));
        JLabel lblChkSaveVdo = new JLabel("Save Output: ");
        JCheckBox chkSaveVdo = new JCheckBox();
        //chkSaveVdo.setEnabled(false);

        //lblChkSaveVdo.setPreferredSize(new Dimension(100,30));

        ingroup5.add(lblChkSaveVdo,BorderLayout.CENTER);
        ingroup5.add(chkSaveVdo,BorderLayout.EAST);
        ingroup5.setPreferredSize(new Dimension(310,30));

        group5.setPreferredSize(new Dimension(350,40));
        group5.add(ingroup5);

        panel.add(group5, gbc);
        
        gbc.gridy++;
        JPanel group6 = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 0));
        JPanel ingroup6 = new JPanel(new BorderLayout());
        //ingroup6.setPreferredSize(new Dimension(100,100));
        JLabel lblChkMaskShade = new JLabel("Shading Mask: ");
        JCheckBox chkhkMaskShade = new JCheckBox();
        chkhkMaskShade.setEnabled(false);

        //lblChkMaskShade.setPreferredSize(new Dimension(100,30));

        ingroup6.add(lblChkMaskShade,BorderLayout.CENTER);
        ingroup6.add(chkhkMaskShade,BorderLayout.EAST);
        ingroup6.setPreferredSize(new Dimension(310,30));

        group6.setPreferredSize(new Dimension(350,40));
        group6.add(ingroup6);

        panel.add(group6, gbc);
        
        comboModelName.addActionListener((ActionEvent e) -> {
            modelName = (String) comboModelName.getSelectedItem();
            if(modelName.equals(ObjectDetector.MODEL_MASK_RCNN))
            {
                chkhkMaskShade.setEnabled(true);
            }
            else
            {
                chkhkMaskShade.setEnabled(false);
            }
        });
        
        comboMediaType.addActionListener((ActionEvent e) -> {
            mediaType = (String) comboMediaType.getSelectedItem();
        });

        comboDeviceType.addActionListener((ActionEvent e) -> {
            deviceType = (String) comboDeviceType.getSelectedItem();
        });

        btnFind1.addActionListener((ActionEvent e) -> {
            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setCurrentDirectory(new File("C:\\"));
            int returnValue = fileChooser.showOpenDialog(null);
            if (returnValue == JFileChooser.APPROVE_OPTION) {
                File selectedFile = fileChooser.getSelectedFile();
                txtModel.setText(selectedFile.getAbsolutePath());
            }
        });

        btnFind2.addActionListener((ActionEvent e) -> {
            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setCurrentDirectory(new File("C:\\"));
            int returnValue = fileChooser.showOpenDialog(null);
            if (returnValue == JFileChooser.APPROVE_OPTION) {
                File selectedFile = fileChooser.getSelectedFile();

                txtConfig.setText(selectedFile.getAbsolutePath());
            }
        });

        btnFind3.addActionListener((ActionEvent e) -> {
            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setCurrentDirectory(new File("C:\\")); // Default directory

            String mType = comboMediaType.getSelectedItem().toString().trim();

            if("Image".equals(mType))
            {
                //chkSaveVdo.setEnabled(false);

                FileNameExtensionFilter filter = new FileNameExtensionFilter(
                        "Image Files (JPG, PNG)", "jpg", "jpeg", "png");
                fileChooser.setFileFilter(filter);
            }
            else if("Video".equals(mType))
            {
                //chkSaveVdo.setEnabled(true);
                FileNameExtensionFilter filter = new FileNameExtensionFilter(
                        "Video Files (MP4)", "mp4");
                fileChooser.setFileFilter(filter);
            }

            int returnValue = fileChooser.showOpenDialog(null);
            if (returnValue == JFileChooser.APPROVE_OPTION) {
                File selectedFile = fileChooser.getSelectedFile();
                txtFileIn.setText(selectedFile.getAbsolutePath());
            }
        });

        // OK / CANCEL button dialog
        int result = JOptionPane.showConfirmDialog(null, panel, WinName,
                JOptionPane.OK_CANCEL_OPTION, JOptionPane.PLAIN_MESSAGE);

        if (result == JOptionPane.OK_OPTION) {
            mediaType = comboMediaType.getSelectedItem().toString().trim();
            deviceType = comboDeviceType.getSelectedItem().toString().trim();
            modelPath = txtModel.getText();
            modelConfiguration = txtConfig.getText();
            mediaFile = txtFileIn.getText();
            threshold = Double.parseDouble(txtThreshold.getText());
            isSaveOutput = chkSaveVdo.isSelected();
            isMaskShading = chkhkMaskShade.isSelected();
            
            return this;
        } else {
            //System.out.println("Cancelled");
            return null;
        }
    }
    
    public static void main(String[] args)
    {
        new DNNOption().setUpOptions();
    }
}
