/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.tobee.opencv.detector.tests.input;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.io.File;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 *
 * @author User
 */
public class DNNOptionTest {
    public static String mediaType;
    public static String deviceType;

    public static String mediaFile;
    public static String modelKind;
    public static String modelConfiguration;
    public static String WinName = "Object detection in OpenCV(${Model})";
    public static boolean isSaveOutput;
    public static double threshold; // Confidence threshold
    public static boolean isDebug = true;
    
    public static boolean isValid()
    {
        boolean isValid;

        isValid = (mediaFile == null ? false : (mediaFile.isBlank() ? false : (!mediaFile.isEmpty())));
        System.out.println(isValid);
        //System.out.println(mediaFile != null && !mediaFile.isBlank() && mediaFile.isEmpty());
        if(!isValid) return false;
        isValid = mediaFile == null ? false : (mediaFile.isBlank() ? false : (!mediaFile.isEmpty()));
        System.out.println(isValid);
        if(!isValid) return false;
        isValid = modelKind == null ? false : (modelKind.isBlank() ? false : (!modelKind.isEmpty()));
        System.out.println(isValid);
        if(!isValid) return false;
        isValid = modelConfiguration == null ? false : (modelConfiguration.isBlank() ? false : (!modelConfiguration.isEmpty()));
        System.out.println(isValid);
        if(!isValid) return false;

        return isValid;
    }

    public static boolean setUpOptions() {
        // Create main panel
        JPanel panel = new JPanel();
        panel.setPreferredSize(new Dimension(400,330));
        panel.setLayout(new GridBagLayout());
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.insets = new Insets(5, 5, 5, 5);
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.gridx = 0;
        gbc.gridy = 0;

        // Create a JComboBox group
        JPanel comboBoxGroup = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 0));
        JComboBox<String> comboMediaType = new JComboBox<>(new String[]{"None", "Image", "Video"});
        JComboBox<String> comboDeviceType = new JComboBox<>(new String[]{"cpu", "gpu"});
        comboBoxGroup.add(comboMediaType);
        comboBoxGroup.add(comboDeviceType);
        comboMediaType.setPreferredSize(new Dimension(150,30));
        comboDeviceType.setPreferredSize(new Dimension(150, 30));
        panel.add(comboBoxGroup, gbc);
        comboBoxGroup.setPreferredSize(new Dimension(320,40));

        // Create  JTextField + JButton Group
        gbc.gridy++;
        JPanel group1 = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 0));
        JPanel ingroup1 = new JPanel(new BorderLayout());
        JLabel lblModel = new JLabel("Model: ");
        JTextField txtModel = new JTextField(10);
        JButton btnFind1 = new JButton("Find");

        txtModel.setPreferredSize(new Dimension(200,30));
        btnFind1.setPreferredSize(new Dimension(60,30));

        ingroup1.add(lblModel,BorderLayout.WEST);
        ingroup1.add(txtModel,BorderLayout.CENTER);
        ingroup1.add(btnFind1,BorderLayout.EAST);
        ingroup1.setPreferredSize(new Dimension(310,30));

        group1.setPreferredSize(new Dimension(350,40));
        group1.add(ingroup1);

        panel.add(group1, gbc);

        // Create  JTextField + JButton Group
        gbc.gridy++;
        JPanel group2 = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 0));
        JPanel ingroup2 = new JPanel(new BorderLayout());
        group2.setPreferredSize(new Dimension(100,100));
        JLabel lblConfig = new JLabel("Config: ");
        JTextField txtConfig = new JTextField(10);
        JButton btnFind2 = new JButton("Find");

        txtConfig.setPreferredSize(new Dimension(200,30));
        btnFind2.setPreferredSize(new Dimension(60,30));

        ingroup2.add(lblConfig,BorderLayout.WEST);
        ingroup2.add(txtConfig,BorderLayout.CENTER);
        ingroup2.add(btnFind2,BorderLayout.EAST);
        ingroup2.setPreferredSize(new Dimension(310,30));

        group2.setPreferredSize(new Dimension(350,40));
        group2.add(ingroup2);

        panel.add(group2, gbc);

        // Create  JTextField + JButton Group 
        gbc.gridy++;
        JPanel group3 = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 0));
        JPanel ingroup3 = new JPanel(new BorderLayout());
        group3.setPreferredSize(new Dimension(100,100));
        JLabel lblFileIn = new JLabel("InFile: ");
        JTextField txtFileIn = new JTextField(10);
        JButton btnFind3 = new JButton("Find");

        txtFileIn.setPreferredSize(new Dimension(200,30));
        btnFind3.setPreferredSize(new Dimension(60,30));

        ingroup3.add(lblFileIn,BorderLayout.WEST);
        ingroup3.add(txtFileIn,BorderLayout.CENTER);
        ingroup3.add(btnFind3,BorderLayout.EAST);
        ingroup3.setPreferredSize(new Dimension(310,30));

        group3.setPreferredSize(new Dimension(350,40));
        group3.add(ingroup3);

        panel.add(group3, gbc);
        
        // Create  JLabel + JCheckBox Group 
        gbc.gridy++;
        JPanel group4 = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 0));
        JPanel ingroup4 = new JPanel(new BorderLayout());
        group4.setPreferredSize(new Dimension(100,100));
        JLabel lblThreshold = new JLabel("Threshold: ");
        JTextField txtThreshold = new JTextField();
        txtThreshold.setHorizontalAlignment(JTextField.RIGHT);
        txtThreshold.setText("0.5");
        
        ingroup4.add(lblThreshold,BorderLayout.WEST);
        ingroup4.add(txtThreshold,BorderLayout.CENTER);
        //ingroup4.add(btnFind3,BorderLayout.EAST);
        ingroup4.setPreferredSize(new Dimension(310,30));
        
        group4.setPreferredSize(new Dimension(350,40));
        group4.add(ingroup4);

        panel.add(group4, gbc);
        
        // Create  JLabel + JCheckBox Group 
        gbc.gridy++;
        JPanel group5 = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 0));
        JPanel ingroup5 = new JPanel(new BorderLayout());
        group5.setPreferredSize(new Dimension(100,100));
        JLabel lblChkSaveVdo = new JLabel("Save Video: ");
        JCheckBox chkSaveVdo = new JCheckBox();
        chkSaveVdo.setEnabled(false);

        lblChkSaveVdo.setPreferredSize(new Dimension(100,30));

        ingroup5.add(lblChkSaveVdo,BorderLayout.CENTER);
        ingroup5.add(chkSaveVdo,BorderLayout.EAST);
        ingroup5.setPreferredSize(new Dimension(310,30));

        group5.setPreferredSize(new Dimension(350,40));
        group5.add(ingroup5);

        panel.add(group5, gbc);

        comboMediaType.addActionListener((ActionEvent e) -> {
            mediaType = (String) comboMediaType.getSelectedItem();
        });

        comboMediaType.addItemListener((ItemEvent e) -> {
            if (e.getStateChange() == ItemEvent.SELECTED) {
                if(e.getItem() == "Video")
                {
                    chkSaveVdo.setEnabled(true);
                }
                else
                {
                    chkSaveVdo.setEnabled(false);
                }
            }
        });

        comboDeviceType.addActionListener((ActionEvent e) -> {
            deviceType = (String) comboDeviceType.getSelectedItem();
        });

        btnFind1.addActionListener((ActionEvent e) -> {
            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setCurrentDirectory(new File("C:\\"));
            int returnValue = fileChooser.showOpenDialog(null);
            if (returnValue == JFileChooser.APPROVE_OPTION) {
                File selectedFile = fileChooser.getSelectedFile();
                txtModel.setText(selectedFile.getAbsolutePath());
            }
        });

        btnFind2.addActionListener((ActionEvent e) -> {
            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setCurrentDirectory(new File("C:\\"));
            int returnValue = fileChooser.showOpenDialog(null);
            if (returnValue == JFileChooser.APPROVE_OPTION) {
                File selectedFile = fileChooser.getSelectedFile();

                txtConfig.setText(selectedFile.getAbsolutePath());
            }
        });

        btnFind3.addActionListener((ActionEvent e) -> {
            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setCurrentDirectory(new File("C:\\")); // Default directory

            String mType = comboMediaType.getSelectedItem().toString().trim();

            if("Image".equals(mType))
            {
                chkSaveVdo.setEnabled(false);

                FileNameExtensionFilter filter = new FileNameExtensionFilter(
                        "Image Files (JPG, PNG)", "jpg", "jpeg", "png");
                fileChooser.setFileFilter(filter);
            }
            else if("Video".equals(mType))
            {
                chkSaveVdo.setEnabled(true);
                FileNameExtensionFilter filter = new FileNameExtensionFilter(
                        "Video Files (MP4)", "mp4");
                fileChooser.setFileFilter(filter);
            }

            int returnValue = fileChooser.showOpenDialog(null);
            if (returnValue == JFileChooser.APPROVE_OPTION) {
                File selectedFile = fileChooser.getSelectedFile();
                txtFileIn.setText(selectedFile.getAbsolutePath());
            }
        });

        // OK / CANCEL button dialog
        int result = JOptionPane.showConfirmDialog(null, panel, WinName.replace("${Model}", "DNN"),
                JOptionPane.OK_CANCEL_OPTION, JOptionPane.PLAIN_MESSAGE);

        if (result == JOptionPane.OK_OPTION) {
            System.out.println("OK clicked");

            mediaType = comboMediaType.getSelectedItem().toString().trim();
            deviceType = comboDeviceType.getSelectedItem().toString().trim();
            modelKind = txtModel.getText();
            modelConfiguration = txtConfig.getText();
            mediaFile = txtFileIn.getText();
            isSaveOutput = chkSaveVdo.isSelected();
            threshold = Double.parseDouble(txtThreshold.getText());
            return true;
        } else {
            //System.out.println("Cancelled");
            return false;
        }
    }
    
    public static void main(String[] args)
    {
        DNNOptionTest.setUpOptions();
    }
}
