/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package conf;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import org.opencv.core.Scalar;

/**
 *
 * @author Tobee
 */
public class CocoLabel {
    private static String COCO_LABLE_FILE;

    private static final Map<Integer, String> COCO_LABLES = new HashMap<>();
    private static final List<Scalar> COLORS = new ArrayList<>();
    
    public static String getLabelFile()
    {
        return COCO_LABLE_FILE;
    }
    
    public static void setupCocoLabelSet(String labelFileName)
    {
        BufferedReader breader;
        COCO_LABLE_FILE = labelFileName;
        
        try
        {
            String line;
            //CocoLabel.class.getResourceAsStream(COCO_LABLE_FILE);
            //breader = new BufferedReader(new InputStreamReader(new FileInputStream(COCO_LABLE_FILE)));
            breader = new BufferedReader(new InputStreamReader(CocoLabel.class.getResourceAsStream(COCO_LABLE_FILE)));

            String labels[];
            while((line = breader.readLine()) != null)
            {
                if(line.isBlank() || line.isEmpty()) continue;
                if(line.startsWith("#")) continue;

                labels = line.split("\\:");

                if(labels.length == 2)
                {
                    COCO_LABLES.put(Integer.valueOf(labels[0]), labels[1].trim());
                }
            }
        }
        catch(IOException ie)
        {
            ie.printStackTrace();
        }
        
        // generate radnom color in order to draw bounding boxes
        Random random = new Random();
        
        for (int i = 0; i < COCO_LABLES.size(); i++) {
            COLORS.add(
                new Scalar(
                    new double[] { random.nextInt(255), random.nextInt(255), random.nextInt(255) }));
        }
    }
    
    
    public static List<Scalar> getColorsByLabel()
    {
        if(!COLORS.isEmpty()) return COLORS;
        return COLORS;
    }
    
    public static Map<Integer, String> getCocoLabel()
    {
        if(!COCO_LABLES.isEmpty()) return COCO_LABLES;
        return COCO_LABLES;
    }
}
