/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package tobee.test;

import java.io.File;
import java.util.List;
import javax.swing.JOptionPane;
import org.opencv.core.Core;
import org.opencv.core.CvType;
import org.opencv.core.Mat;
import org.opencv.core.Rect2d;
import org.opencv.core.Size;
import org.opencv.highgui.HighGui;
import org.opencv.videoio.VideoCapture;
import org.opencv.videoio.VideoWriter;
import org.opencv.videoio.Videoio;

/**
 *
 * @author User
 */
public class OpeCVideoWriter {
    public static void main(String[] args) {
        // OpenCV 라이브러리 로드
        System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
        
        String inFile = "C:\\DEV\\Experimental\\Vision\\data\\videos\\vtest.avi";
        String outputFile = "C:\\DEV\\Experimental\\Vision\\data\\videos\\vtest_out.avi";
        // 비디오 캡처 객체 생성
        VideoCapture capture = new VideoCapture();
        
        // FPS 값을 가져오기
        double fps = capture.get(Videoio.CAP_PROP_FPS);
        System.out.println("FPS: " + fps);
        double frmCount = capture.get(Videoio.CAP_PROP_FRAME_COUNT);
        System.out.println("frmCount = " + frmCount);
        
        System.out.println("fps: " + fps);
        if(fps == 0D)
        {
            fps = 20;
        }
        
        // 비디오 캡처 객체에서 프레임 읽기
        Mat frame = new Mat();
        String winName = "mywindow";
        boolean isSaveOuput = true;
        if (capture.open(inFile)) {
            capture.read(frame);
            HighGui.imshow(winName, frame);
        } else {
            System.out.println("Capture is not opened!");
            return;
        }
        Size size 
            = new Size(capture.get(Videoio.CAP_PROP_FRAME_WIDTH), capture.get(Videoio.CAP_PROP_FRAME_HEIGHT));
        int fourcc_mjpg = org.opencv.videoio.VideoWriter.fourcc('M', 'J', 'P', 'G');  //# Motion JPEG format
        
        VideoWriter vwriter = new VideoWriter(/*outputFile, fourcc_mjpg, fps, size, true*/);
        
        Mat detectedFrame = new Mat();
        
        while (capture.isOpened()) {
           if(HighGui.waitKey(100) == 27) //ESC key to exit
           {
               System.out.println( "[ESC]Done processing !!!");
               //System.out.println( "[ESC]Output file is stored as " + outputFile);
               HighGui.waitKey(3000);
               break;
           }
            // get frame from the video
           capture.read(frame);

           // Stop the program if reached end of video
           if (frame.empty()) {
               System.out.println( "Done processing !!!");
               //System.out.println( "Output file is stored as " + outputFile);
               HighGui.waitKey(1000);

               if(vwriter.isOpened()) {
                   vwriter.release();
               } 
               
               break;
           }

           HighGui.imshow(winName, frame);

           if(isSaveOuput)
           {
               if(new File(outputFile).exists())
               {
                   System.out.println(String.format("Can not open the video file[sz:%s, fps:%f]", size.toString(), fps));
               }
               
               isSaveOuput = vwriter.open(outputFile, fourcc_mjpg, 30, new Size(640, 480));

                if (!isSaveOuput) {
                    System.out.println("파일을 열 수 없습니다. 경로와 이름을 다시 확인하세요.");
                } else {
                    System.out.println("파일이 정상적으로 열렸습니다.");
                }
               
               //isSaveOuput = vwriter.open(outputFile, fourcc_mjpg, fps, size, true);
                
               if(!isSaveOuput)
               {
                   JOptionPane.showMessageDialog(null, 
                       String.format("Can not open the video file[sz:%s, fps:%f]", size.toString(), fps), 
                       "error", JOptionPane.INFORMATION_MESSAGE);
                   break;
               }

                frame.convertTo(detectedFrame, CvType.CV_8U);
               if(vwriter.isOpened()) 
               {
                   vwriter.write(detectedFrame);
               }
               else
               {
                   System.out.println("========vwriter is not opened=======");
               }
           }
        }
        // 캡처 객체 닫기
        capture.release();
    }
}
