/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package tobee.test;

import org.opencv.core.Core;
import org.opencv.core.Mat;
import org.opencv.videoio.VideoCapture;
import org.opencv.videoio.Videoio;

public class OpenCVideoFPS {
    public static void main(String[] args) {
        // OpenCV 라이브러리 로드
        System.loadLibrary(Core.NATIVE_LIBRARY_NAME);

        // 비디오 캡처 객체 생성
        VideoCapture capture = new VideoCapture("C:\\DEV\\Experimental\\Vision\\data\\videos\\vtest.avi");

        // 비디오 파일 열기 확인
        if (!capture.isOpened()) {
            System.out.println("비디오 파일을 열 수 없습니다.");
            return;
        }

        // FPS 값을 가져오기
        double fps = capture.get(Videoio.CAP_PROP_FPS);
        System.out.println("FPS: " + fps);

        // 비디오 캡처 객체에서 프레임 읽기
        Mat frame = new Mat();
        while (capture.read(frame)) {
            // 프레임 처리 로직
            System.out.println("프레임 처리 중...");
        }

        // 캡처 객체 닫기
        capture.release();
    }
}

