/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package tobee.test;

import org.opencv.core.Core;
import org.opencv.core.Mat;
import org.opencv.core.Size;
import org.opencv.imgproc.Imgproc;
import org.opencv.videoio.VideoCapture;
import org.opencv.videoio.VideoWriter;
import org.opencv.videoio.Videoio;

public class VideoProcessing {
    public static void main(String[] args) {
        // OpenCV 라이브러리 로드
        System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
        
        String inFile = "C:\\DEV\\Experimental\\Vision\\data\\videos\\vtest.avi";
        String outputFile = "C:\\DEV\\Experimental\\Vision\\data\\videos\\vtest_out.avi";
        
        // 비디오 캡처 객체 생성
        VideoCapture capture = new VideoCapture(inFile);

        // 비디오 파일 열기 확인
        if (!capture.isOpened()) {
            System.out.println("비디오 파일을 열 수 없습니다.");
            return;
        }

        // 원본 비디오의 프레임 크기 가져오기
        double frameWidth = capture.get(Videoio.CAP_PROP_FRAME_WIDTH);
        double frameHeight = capture.get(Videoio.CAP_PROP_FRAME_HEIGHT);
        int fourcc_mjpg = org.opencv.videoio.VideoWriter.fourcc('M', 'J', 'P', 'G');  //# Motion JPEG format
        
        // 비디오 작성기 설정 (MP4V 사용)
        VideoWriter writer = new VideoWriter();
        boolean isOpened = writer.open(outputFile, fourcc_mjpg, 30, new Size(frameWidth, frameHeight));

        if (!isOpened) {
            System.out.println("파일을 열 수 없습니다. 경로와 이름을 다시 확인하세요.");
            return;
        }

        // 비디오 캡처 및 저장
        while (capture.isOpened()) {
            Mat frame = new Mat();
            if (!capture.read(frame)) {
                break;
            }

            // 채널 수 확인 (3채널 컬러로 변환)
//            if (frame.channels() != 3) {
//                // 흑백 이미지를 컬러로 변환 (필요한 경우)
//                Mat colorFrame = new Mat();
//                if (frame.channels() == 1) {
//                    // 흑백 이미지를 컬러로 변환
//                    Imgproc.cvtColor(frame, colorFrame, Imgproc.COLOR_GRAY2BGR);
//                    frame = colorFrame;
//                }
//            }

            writer.write(frame); // 프레임 저장

            // 프레임 처리 코드
            System.out.println("프레임 처리 중...");
        }

        // 캡처 및 작성기 해제
        capture.release();
        writer.release();
    }
}

